## syslog-ng 3.27.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
set(CMAKE_MACOSX_RPATH 1)

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

project(syslog-ng C)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules ${PROJECT_SOURCE_DIR}/cmake/)
set(CMAKE_POSITION_INDEPENDENT_CODE 1)
set(BISON_FLAGS "-Wno-other -Werror=conflicts-sr -Werror=conflicts-rr")

include(CheckIncludeFiles)
include(ExternalProject)
include(external_or_find_package)
include(add_module)
include(add_tests)
include(module_switch)

set(MEMORYCHECK_SUPPRESSIONS_FILE "${PROJECT_SOURCE_DIR}/tests/valgrind/unit-test-leak.supp")
set(MEMORYCHECK_COMMAND_OPTIONS "--num-callers=30 --sim-hints=no-nptl-pthread-stackcache --gen-suppressions=all --leak-check=full --freelist-vol=200000000 --freelist-big-blocks=10000000 --malloc-fill=55 --free-fill=AA")

execute_process(COMMAND ${PROJECT_SOURCE_DIR}/scripts/version.sh SET OUTPUT_VARIABLE SYSLOG_NG_VERSION)
set(SYSLOG_NG_COMBINED_VERSION ${SYSLOG_NG_VERSION})
set(SYSLOG_NG_SOURCE_REVISION ${SYSLOG_NG_VERSION})

set(SYSLOG_NG_PATH_PREFIX ${CMAKE_INSTALL_PREFIX})
set(SYSLOG_NG_PATH_SYSCONFDIR "\${prefix}/etc")
set(SYSLOG_NG_PATH_DATADIR "\${datarootdir}")
set(SYSLOG_NG_PATH_PIDFILEDIR "\${localstatedir}")
set(SYSLOG_NG_PATH_LOCALSTATEDIR "\${prefix}/var")
set(SYSLOG_NG_MODULE_PATH "\${exec_prefix}/lib/syslog-ng")
set(SYSLOG_NG_PATH_EXECPREFIX "\${prefix}")
set(SYSLOG_NG_PATH_CONFIG_INCLUDEDIR "\${datadir}/syslog-ng/include")
set(SYSLOG_NG_PATH_SCLDIR "\${datadir}/syslog-ng/include/scl")
set(SYSLOG_NG_PATH_LIBEXECDIR "\${exec_prefix}/libexec")
set(SYSLOG_NG_PATH_DATAROOTDIR "\${prefix}/share")
set(SYSLOG_NG_ENABLE_TCP_WRAPPER 0)
set(SYSLOG_NG_ENABLE_GPROF 0)
set(SYSLOG_NG_ENABLE_MEMTRACE 0)
set(SYSLOG_NG_ENABLE_SYSTEMD 0)
set(SYSLOG_NG_PATH_MODULEDIR "\${exec_prefix}/lib/syslog-ng")
set(SYSLOG_NG_PACKAGE_NAME "${CMAKE_PROJECT_NAME}")
set(SYSLOG_NG_PATH_XSDDIR "\${datadir}/syslog-ng/xsd")
set(SYSLOG_NG_JAVA_MODULE_PATH "\${exec_prefix}/lib/syslog-ng/java-modules")
set(SYSLOG_NG_PYTHON_MODULE_DIR "\${exec_prefix}/lib/syslog-ng/python")
set(SYSLOG_NG_PATH_TOPSRC_DIR "${PROJECT_SOURCE_DIR}")
set(LIBDIR "\${exec_prefix}/lib")
set(INCLUDEDIR "\${prefix}/include")
set(TOOLSDIR "\${datadir}/syslog-ng/tools")
set(SYSLOG_NG_ENABLE_FORCED_SERVER_MODE 1)

set (LOGGEN_PLUGIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib/syslog-ng/loggen")

IF(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
  set(SYSLOG_NG_ENABLE_DEBUG 1)
ELSE()
  set(SYSLOG_NG_ENABLE_DEBUG 0)
ENDIF()

include(CheckTypeSize)
include(CheckStructMember)
include(CheckSymbolExists)
include(GenerateYFromYm)
include(CheckStructHasMember)
include(CheckCSourceCompiles)

add_definitions(-D_GNU_SOURCE=1)
add_definitions(-D_LARGEFILE64_SOURCE=1)

include(CheckSockaddrStorage)
if (HAVE_STRUCT_SOCKADDR_STORAGE)
    set(SYSLOG_NG_HAVE_STRUCT_SOCKADDR_STORAGE 1)
else()
    set(SYSLOG_NG_HAVE_STRUCT_SOCKADDR_STORAGE 0)
endif()

include(CheckCreds)
set(SYSLOG_NG_HAVE_STRUCT_UCRED (HAVE_STRUCT_UCRED OR HAVE_STRUCT_CMSGCRED))
check_struct_member ("struct msghdr" "msg_control" "sys/types.h;sys/socket.h" SYSLOG_NG_HAVE_CTRLBUF_IN_MSGHDR)

include(CheckIPv6)

module_switch(ENABLE_IPV6 "Enable IPv6")
if (ENABLE_IPV6)
    set(SYSLOG_NG_ENABLE_IPV6 ${HAVE_IPV6})
endif()

if (NOT APPLE)
  set(SYSLOG_NG_HAVE_ENVIRON 1)
endif()

option(ENV_LD_LIBRARY_PATH "Set LD_LIBRARY_PATH during runtime to the value given" "")
if (ENV_LD_LIBRARY_PATH)
  set(SYSLOG_NG_ENABLE_ENV_WRAPPER 1)
endif()

option(WITH_COMPILE_DATE "Include compile date in binary" "ON")
if (WITH_COMPILE_DATE)
  set(SYSLOG_NG_WITH_COMPILE_DATE 1)
endif()

set(CMAKE_REQUIRED_DEFINITIONS "-D_LARGEFILE64_SOURCE=1")
set(CMAKE_EXTRA_INCLUDE_FILES "fcntl.h")
check_type_size(O_LARGEFILE O_LARGEFILE)
if (HAVE_O_LARGEFILE)
  set(SYSLOG_NG_HAVE_O_LARGEFILE 1)
endif()

check_c_source_compiles("
#include <pthread.h>
__thread int a; int main() { a=0; }" SYSLOG_NG_HAVE_THREAD_KEYWORD)


check_symbol_exists(strtoll stdlib.h SYSLOG_NG_HAVE_STRTOLL)
check_symbol_exists(strnlen string.h SYSLOG_NG_HAVE_STRNLEN)
check_symbol_exists(strtok_r string.h SYSLOG_NG_HAVE_STRTOK_R)
check_symbol_exists(strtoimax inttypes.h SYSLOG_NG_HAVE_STRTOIMAX)
check_symbol_exists(inet_aton "sys/socket.h;netinet/in.h;arpa/inet.h" SYSLOG_NG_HAVE_INET_ATON)
check_symbol_exists(inet_ntoa "sys/socket.h;netinet/in.h;arpa/inet.h" SYSLOG_NG_HAVE_INET_NTOA)
check_symbol_exists(getutent utmp.h SYSLOG_NG_HAVE_GETUTENT)
check_symbol_exists(getutxent utmpx.h SYSLOG_NG_HAVE_GETUTXENT)
check_symbol_exists(getaddrinfo "netdb.h;sys/socket.h;sys/types.h" SYSLOG_NG_HAVE_GETADDRINFO)
check_symbol_exists(getnameinfo "netdb.h;sys/socket.h" SYSLOG_NG_HAVE_GETNAMEINFO)
check_symbol_exists(getprotobynumber_r "netdb.h" SYSLOG_NG_HAVE_GETPROTOBYNUMBER_R)
check_symbol_exists(clock_gettime "time.h" SYSLOG_NG_HAVE_CLOCK_GETTIME)
check_symbol_exists(gmtime_r "time.h" SYSLOG_NG_HAVE_GMTIME_R)
check_symbol_exists(localtime_r "time.h" SYSLOG_NG_HAVE_LOCALTIME_R)
check_symbol_exists("getrandom" "sys/random.h" SYSLOG_NG_HAVE_GETRANDOM)
check_symbol_exists(fmemopen "stdio.h" SYSLOG_NG_HAVE_FMEMOPEN)
set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
check_symbol_exists(memrchr "string.h" SYSLOG_NG_HAVE_MEMRCHR)
check_symbol_exists(strcasestr "string.h" SYSLOG_NG_HAVE_STRCASESTR)
check_symbol_exists(pread "unistd.h" SYSLOG_NG_HAVE_PREAD)
check_symbol_exists(pwrite "unistd.h" SYSLOG_NG_HAVE_PWRITE)
check_symbol_exists(timezone time.h SYSLOG_NG_HAVE_TIMEZONE)

check_include_files(utmp.h SYSLOG_NG_HAVE_UTMP_H)
check_include_files(utmpx.h SYSLOG_NG_HAVE_UTMPX_H)
check_include_files(dlfcn.h SYSLOG_NG_HAVE_DLFCN_H)
check_include_files(getopt.h SYSLOG_NG_HAVE_GETOPT_H)

check_struct_has_member("struct utmpx" "ut_type" "utmpx.h" UTMPX_HAS_UT_TYPE LANGUAGE C)
check_struct_has_member("struct utmp" "ut_type" "utmp.h" UTMP_HAS_UT_TYPE LANGUAGE C)
check_struct_has_member("struct utmpx" "ut_user" "utmpx.h" UTMPX_HAS_UT_USER LANGUAGE C)
check_struct_has_member("struct utmp" "ut_user" "utmp.h" UTMP_HAS_UT_USER LANGUAGE C)
check_struct_has_member("struct tm" "tm_gmtoff" "sys/time.h;time.h" SYSLOG_NG_HAVE_STRUCT_TM_TM_GMTOFF)


if ((UTMPX_HAS_UT_TYPE AND UTMPX_HAS_UT_USER) OR (UTMPX_HAS_UT_TYPE AND UTMP_HAS_UT_USER))
  set(SYSLOG_NG_HAVE_MODERN_UTMP 1)
endif()

set(WITH_GETTEXT "" CACHE STRING "Set the prefix where gettext is installed (e.g. /usr)")

set(CMAKE_C_STANDARD 99)

find_package(BISON 2.4 REQUIRED)
find_package(GLIB COMPONENTS gmodule gthread 2.26.1 REQUIRED)

set(CMAKE_REQUIRED_INCLUDES ${GLIB_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES ${GLIB_LIBRARIES})
check_symbol_exists(g_list_copy_deep "glib.h" SYSLOG_NG_HAVE_G_LIST_COPY_DEEP)
check_symbol_exists(g_queue_free_full "glib.h" SYSLOG_NG_HAVE_G_QUEUE_FREE_FULL)
check_symbol_exists(g_list_free_full "glib.h" SYSLOG_NG_HAVE_G_LIST_FREE_FULL)
check_symbol_exists(g_ptr_array_find_with_equal_func "glib.h" SYSLOG_NG_HAVE_G_PTR_ARRAY_FIND_WITH_EQUAL_FUNC)
check_symbol_exists(g_canonicalize_filename "glib.h" SYSLOG_NG_HAVE_G_CANONICALIZE_FILENAME)
check_symbol_exists(g_hash_table_contains "glib.h" SYSLOG_NG_HAVE_G_HASH_TABLE_CONTAINS)

find_package(RabbitMQ)
set(CMAKE_REQUIRED_INCLUDES ${RabbitMQ_INCLUDE_DIR})
set(CMAKE_REQUIRED_LIBRARIES ${RabbitMQ_LIBRARY})
check_symbol_exists(amqp_ssl_socket_set_verify_peer "amqp.h;amqp_ssl_socket.h" SYSLOG_NG_HAVE_AMQP_SSL_SOCKET_SET_VERIFY_PEER)


set (SYSLOG_NG_USE_CONST_IVYKIS_MOCK 1)
external_or_find_package(IVYKIS REQUIRED)
if ((NOT IVYKIS_INTERNAL) AND (IVYKIS_PKGCONF_VERSION VERSION_LESS "0.39"))
  set (SYSLOG_NG_USE_CONST_IVYKIS_MOCK 0)
endif()

find_package(OpenSSL REQUIRED)
find_package(FLEX REQUIRED)
find_package(LibNet REQUIRED)
find_package(Resolv REQUIRED)
find_package(Wrap)
find_package(criterion)
find_package(Inotify)
find_package(LIBCAP)

find_package(systemd)
module_switch(ENABLE_JOURNALD "Enable systemd-journal" Libsystemd_FOUND)
set(WITH_SYSTEMD_JOURNAL "system" CACHE STRING "Link against the system supplied or the wrapper library")
set_property(CACHE WITH_SYSTEMD_JOURNAL PROPERTY STRINGS system wrapper)

if (ENABLE_JOURNALD)
  if (WITH_SYSTEMD_JOURNAL STREQUAL "system" AND NOT Libsystemd_FOUND)
    message(FATAL_ERROR "systemd library not found")
  endif()

  set(SYSLOG_NG_ENABLE_SYSTEMD 1)
  if (WITH_SYSTEMD_JOURNAL STREQUAL "system")
    set(SYSLOG_NG_SYSTEMD_JOURNAL_MODE SYSLOG_NG_JOURNALD_SYSTEM)
  elseif (WITH_SYSTEMD_JOURNAL STREQUAL "wrapper")
    set(SYSLOG_NG_SYSTEMD_JOURNAL_MODE SYSLOG_NG_JOURNALD_OPTIONAL)
  endif()
else()
  set(SYSLOG_NG_ENABLE_SYSTEMD 0)
  set(SYSLOG_NG_SYSTEMD_JOURNAL_MODE SYSLOG_NG_JOURNALD_OFF)
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
set(SYSLOG_NG_HAVE_INOTIFY "${Inotify_FOUND}")

set (PYTHON_VERSION "AUTO" CACHE STRING "Version of the installed development library" )

if ("${PYTHON_VERSION}" STREQUAL "AUTO")
  find_package(PythonInterp)
  find_package(PythonLibs)
else ()
  find_package(PythonInterp EXACT "${PYTHON_VERSION}" REQUIRED)
  find_package(PythonLibs EXACT "${PYTHON_VERSION}" REQUIRED)
endif ()

MESSAGE(STATUS "Detected pythonlib version: ${PYTHONLIBS_VERSION_STRING}")

set (NOSETESTS "" CACHE STRING "nosetests binary")
set (PYLINT "" CACHE STRING "pylint binary")

if (NOSETESTS)
  set(NOSETESTS_BIN ${NOSETESTS})
else ()
  if (PYTHON_VERSION STREQUAL "3")
    find_program(NOSETESTS_BIN "nosetests3")
      if (NOT NOSETESTS_BIN)
        find_program(NOSETESTS_BIN "nosetests")
      endif()
  else ()
    find_program(NOSETESTS_BIN "nosetests")
  endif ()
endif()

if (PYLINT)
  set(PYLINT_BIN ${PYLINT})
else ()
  if (PYTHON_VERSION STREQUAL "3")
    find_program(PYLINT_BIN "pylint3")
      if (NOT PYLINT_BIN)
        find_program(PYLINT_BIN "pylint")
      endif()
  else ()
    find_program(PYLINT_BIN "pylint")
  endif ()
endif()

if (PYTHONLIBS_VERSION_STRING VERSION_LESS 3)
    set(SYSLOG_NG_ENABLE_PYTHONv2 1)
else ()
    set(SYSLOG_NG_ENABLE_PYTHONv3 1)
endif ()


include(openssl_functions)
openssl_set_defines()

pkg_check_modules(LIBPCRE REQUIRED libpcre)

if (WRAP_FOUND)
  set(SYSLOG_NG_ENABLE_TCP_WRAPPER 1)
endif()

if (LIBNET_FOUND)
  set(SYSLOG_NG_ENABLE_SPOOF_SOURCE 1)
endif()

set(SYSLOG_NG_ENABLE_LINUX_CAPS ${LIBCAP_FOUND})

if (WITH_GETTEXT)
    set(CMAKE_PREFIX_PATH ${WITH_GETTEXT})
    find_package(Gettext REQUIRED QUIET)
    set(CMAKE_PREFIX_PATH "")
else()
    find_package(Gettext REQUIRED QUIET)
endif()

set(Eventlog_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/lib/eventlog/src")

add_custom_target(style-check  COMMAND ${PROJECT_SOURCE_DIR}/scripts/style-checker.sh check  ${PROJECT_SOURCE_DIR} ${PROJECT_BINARY_DIR})
add_custom_target(style-format COMMAND ${PROJECT_SOURCE_DIR}/scripts/style-checker.sh format ${PROJECT_SOURCE_DIR} ${PROJECT_BINARY_DIR})
add_custom_target(check-commits
  COMMAND ${PROJECT_SOURCE_DIR}/tests/commits/check.sh
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
add_custom_target(check-copyright
  COMMAND ${PROJECT_SOURCE_DIR}/tests/copyright/check.sh . ${PROJECT_BINARY_DIR} policy
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
set_target_properties(check-copyright PROPERTIES
  ADDITIONAL_MAKE_CLEAN_FILES
  "copyright-run.log;copyright-err.log")

# The inclusion of CTest triggers enable_testing()
# CMake will generate tests only if the enable_testing() command has been invoked.
# The CTest module invokes the command automatically when the BUILD_TESTING option is ON.

if (CRITERION_FOUND)
  option(BUILD_TESTING "Enable unit tests" ON)
else()
  option(BUILD_TESTING  "Enable unit tests" OFF)
endif()

if (BUILD_TESTING AND NOT CRITERION_FOUND)

=== lib/compat/CMakeLists.txt ===
set(COMPAT_HEADERS
    compat/compat.h
    compat/getutent.h
    compat/glib.h
    compat/lfs.h
    compat/pio.h
    compat/socket.h
    compat/string.h
    compat/time.h
    compat/openssl_support.h
    compat/pcre.h
    compat/getent.h
    compat/getent-sun.h
    compat/getent-generic.h
    compat/un.h
    compat/un.h
    PARENT_SCOPE)

set(COMPAT_SOURCES
    compat/getutent.c
    compat/glib.c
    compat/inet_aton.c
    compat/memrchr.c
    compat/pio.c
    compat/strcasestr.c
    compat/strtok_r.c
    compat/strnlen.c
    compat/time.c
    compat/openssl_support.c
    compat/getent-sun.c
    compat/getent-generic.c
    PARENT_SCOPE)

add_test_subdirectory(tests)

=== modules/secure-logging/CMakeLists.txt ===
set (SECURE_LOGGING_SOURCES
  secure-logging.c
  slog.c
  slog.h
)

find_package(OpenSSL)

if (OPENSSL_FOUND)
    add_library(secure-logging SHARED ${SECURE_LOGGING_SOURCES})
    target_include_directories (secure-logging PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
    target_include_directories (secure-logging PRIVATE SYSTEM ${OPENSSL_INCLUDE_DIR})
    target_link_libraries(secure-logging PRIVATE syslog-ng ${OPENSSL_LIBRARIES})

    install(TARGETS secure-logging LIBRARY DESTINATION lib/syslog-ng/ COMPONENT secure-logging)

    add_test_subdirectory(slogimport)
    add_test_subdirectory(slogkey)
    add_test_subdirectory(slogverify)
    add_test_subdirectory(tests)
endif()

=== tests/loggen/CMakeLists.txt ===
# ########### loggen_helper static lib ##############
set(LOGGEN_HELPER_SOURCE
  loggen_helper.c
  loggen_helper.h
  ${PROJECT_SOURCE_DIR}/lib/crypto.c
  ${PROJECT_SOURCE_DIR}/lib/compat/openssl_support.c
  ${PROJECT_SOURCE_DIR}/lib/compat/glib.c
  )

add_library(loggen_helper STATIC ${LOGGEN_HELPER_SOURCE})

include_directories(loggen_helper PUBLIC
  ${CORE_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${GLIB_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/lib
  )

target_link_libraries(
  loggen_helper
  PUBLIC
  ${GLIB_GMODULE_LIBRARIES}
  ${GLIB_GTHREAD_LIBRARIES}
  ${GLIB_LIBRARIES}
  OpenSSL::SSL
  )

set_target_properties(loggen_helper
    PROPERTIES VERSION ${SYSLOG_NG_VERSION}
    SOVERSION ${SYSLOG_NG_VERSION})

install(TARGETS loggen_helper ARCHIVE DESTINATION ${LOGGEN_PLUGIN_INSTALL_DIR})

# ########### loggen_plugin common static lib for plugins #####
set(LOGGEN_PLUGIN_SOURCE
  loggen_plugin.c
  loggen_plugin.h
  )

add_library(loggen_plugin STATIC ${LOGGEN_HELPER_SOURCE})

include_directories(loggen_plugin PUBLIC loggen_helper)

set_target_properties(loggen_plugin
    PROPERTIES VERSION ${SYSLOG_NG_VERSION}
    SOVERSION ${SYSLOG_NG_VERSION})

install(TARGETS loggen_plugin ARCHIVE DESTINATION ${LOGGEN_PLUGIN_INSTALL_DIR})

# ########### loggen binary #################
set(LOGGEN_SOURCE
    loggen.c
    loggen_plugin.h
    file_reader.c
    file_reader.h
    logline_generator.c
    logline_generator.h
    ${PROJECT_SOURCE_DIR}/lib/reloc.c
    ${PROJECT_SOURCE_DIR}/lib/cache.c
    )

add_executable(loggen ${LOGGEN_SOURCE})

target_compile_definitions(loggen PUBLIC
  SYSLOG_NG_PATH_LOGGENPLUGINDIR="${LOGGEN_PLUGIN_INSTALL_DIR}"
  )

target_link_libraries(
  loggen
  loggen_helper)

install(TARGETS loggen RUNTIME DESTINATION bin)

# ################# install dev headers ############

set(INTERFACE_HEADERS
    loggen_plugin.h
    loggen_helper.h
)

install(FILES ${INTERFACE_HEADERS} DESTINATION include/syslog-ng)

# ################# build plugins ############
set(LOGGEN_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_subdirectory(socket_plugin)
add_subdirectory(ssl_plugin)
add_subdirectory(tests)

=== modules/secure-logging/slogimport/CMakeLists.txt ===

add_executable(slogimport slogimport.c)
target_include_directories (secure-logging PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})	
target_link_libraries(slogimport eventlog syslog-ng secure-logging)
set_target_properties(slogimport PROPERTIES COMPILE_FLAGS "-Wno-pointer-sign")
install(TARGETS slogimport RUNTIME DESTINATION bin)

=== modules/secure-logging/slogkey/CMakeLists.txt ===

add_executable(slogkey slogkey.c)
target_include_directories (secure-logging PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})	
target_link_libraries(slogkey eventlog syslog-ng secure-logging)
set_target_properties(slogkey PROPERTIES COMPILE_FLAGS "-Wno-pointer-sign")
install(TARGETS slogkey RUNTIME DESTINATION bin)

=== modules/secure-logging/slogverify/CMakeLists.txt ===

add_executable(slogverify slogverify.c)
target_include_directories (secure-logging PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})	
target_link_libraries(slogverify eventlog syslog-ng secure-logging)
set_target_properties(slogverify PROPERTIES COMPILE_FLAGS "-Wno-pointer-sign")
install(TARGETS slogverify RUNTIME DESTINATION bin)

=== tests/loggen/ssl_plugin/CMakeLists.txt ===
include_directories(loggen_ssl_plugin
  ${CORE_INCLUDE_DIRS}
  ${GLIB_INCLUDE_DIRS}
  ${LOGGEN_INCLUDE_DIR}
  )

set (LOGGEN_SSL_PLUGIN_SOURCE
  ssl_plugin.c
  ${LOGGEN_INCLUDE_DIR}/loggen_plugin.h
  ${LOGGEN_INCLUDE_DIR}/loggen_plugin.c
  )

add_library(loggen_ssl_plugin
  SHARED
  ${LOGGEN_SSL_PLUGIN_SOURCE}
  )

target_link_libraries(
  loggen_ssl_plugin
  loggen_helper
  ${GLIB_GMODULE_LIBRARIES}
  ${GLIB_GTHREAD_LIBRARIES}
  ${GLIB_LIBRARIES}
  OpenSSL::SSL
  )

set_target_properties(loggen_ssl_plugin
    PROPERTIES VERSION ${SYSLOG_NG_VERSION}
    SOVERSION ${SYSLOG_NG_VERSION})

install(TARGETS loggen_ssl_plugin LIBRARY DESTINATION ${LOGGEN_PLUGIN_INSTALL_DIR})

=== debian/changelog ===
syslog-ng (3.27.1-3build1) groovy; urgency=medium

  * Rebuild against new json-c5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jul 2020 19:56:17 +0200

syslog-ng (3.27.1-3) unstable; urgency=medium

  * Fix sumologic.conf installation.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 16 Jun 2020 22:16:59 +0200

syslog-ng (3.27.1-2) unstable; urgency=medium

  * Fix self-tests as mod-snmptrapd-parser merged to mod-snmp package
    (closes: #962893).
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 16 Jun 2020 19:04:17 +0200

syslog-ng (3.27.1-1) unstable; urgency=medium

  * New upstream release:
    - builds with Bison 3.6.1 (closes: #960481).
  * Merge snmptrapd-parser mod to snmp mod.
  * Backport fix for hang on boot due to lack of entropy (closes: #913754).
  * Remove merged in patches.
  * Update configuration version.

  [ Balazs Scheidler <bazsi77@gmail.com> ]
  * Add support for the snmp() destination (syslog-ng-mod-snmp package).
  * Move the http() destination into a separate package (syslog-ng-mod-http).
  * Move BSD process accounting (pacct) support into the core package.
  * Move tags-parser() to the core package.
  * Add support for librdkafka based kafka destination (in mod-rdkafka
    package).
  * Use upstream scl.conf .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 17 May 2020 14:41:30 +0200

=== debian/control ===
Source: syslog-ng
Section: admin
Priority: optional
Maintainer: syslog-ng maintainers <syslog-ng-maintainers@alioth-lists.debian.net>
Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>,
           SZALAY Attila <sasa@debian.org>
Build-Depends: debhelper (>= 10~),
               automake (>= 1:1.11.1),
               autoconf-archive,
               tzdata,
               pkg-config, flex, bison (>= 3.4.2),
               xsltproc, docbook-xsl,
               libesmtp-dev,
               libivykis-dev (>= 0.36.1~),
               libnet1-dev,
               libglib2.0-dev,
               libdbi-dev | libdbi0-dev,
               libssl-dev,
               libmongoc-dev,
               libbson-dev,
               libjson-c-dev | libjson0-dev,
               libwrap0-dev,
               libpcre3-dev,
               libcap-dev [linux-any],
               libsystemd-dev (>= 209) [linux-any],
               libhiredis-dev,
               libriemann-client-dev (>= 1.6.0~),
               librabbitmq-dev,
               python3, python3-dev, pylint3, dh-python,
               dh-exec (>= 0.13~),
               python3-nose, python3-ply,
               libxml2-utils, geoip-database,
               libmaxminddb-dev,
               libcurl4-openssl-dev,
               libsnappy-dev,
               libsnmp-dev [linux-any hurd-i386],
               librdkafka-dev (>= 1.0.0)
Build-Conflicts: autoconf2.13
Standards-Version: 4.5.0
Homepage: https://www.syslog-ng.com/
Vcs-Git: https://github.com/gcsideal/syslog-ng-debian.git
Vcs-Browser: https://github.com/gcsideal/syslog-ng-debian

Package: syslog-ng
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, syslog-ng-core (>= ${source:Upstream-Version}), ${sng:CoreModules}
Recommends: ${sng:Modules}
Description: Enhanced system logging daemon (metapackage)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package is a metapackage, depending on the rest of syslog-ng,
 including all available plugins. It can be safely removed, if only
 parts of syslog-ng need to be installed.

Package: syslog-ng-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: syslog-ng-core (= ${binary:Version}), ${misc:Depends}
Description: Enhanced system logging daemon (debug symbols)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package contains debug symbols for the whole of syslog-ng,
 including the modules.

Package: syslog-ng-dev
Section: libdevel
Architecture: any
Depends: syslog-ng-core (= ${binary:Version}),
 ${misc:Depends}, ${perl:Depends},
 pkg-config, perl, flex, bison, python3,
 libglib2.0-dev, libivykis-dev (>= 0.30)
Description: Enhanced system logging daemon (development files)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package contains the headers and tools needed to build
 third-party plugins against syslog-ng, the next generation system
 logging daemon.

Package: syslog-ng-core
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, util-linux (>= 2.12-10), lsb-base (>= 3.0-6)
Recommends: logrotate
Suggests: ${sng:CoreModules}, ${sng:Modules}
Provides: system-log-daemon, linux-kernel-log-daemon, libsyslog-ng-dev, syslog-ng-mod-journal, syslog-ng-mod-pacctformat [linux-any], syslog-ng-mod-tag-parser
Conflicts: system-log-daemon, linux-kernel-log-daemon
Replaces: syslog-ng (<< 3.3.0~), libsyslog-ng-dev, syslog-ng-mod-json (<< 3.19.1~), syslog-ng-mod-journal (<< 3.25.1~), syslog-ng-mod-pacctformat (<< 3.26.1~), syslog-ng-mod-tag-parser (<< 3.26.1~)
Breaks: syslog-ng (<< 3.3.0~), libsyslog-ng-dev, syslog-ng-mod-json (<< 3.19.1~), syslog-ng-mod-journal (<< 3.25.1~), syslog-ng-mod-pacctformat (<< 3.26.1~), syslog-ng-mod-tag-parser (<< 3.26.1~)
Description: Enhanced system logging daemon (core)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package provides the core syslog-ng, with all the plugins
 required for a standard installation.

Package: syslog-ng-mod-mongodb
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, syslog-ng-core (>= ${source:Version}), syslog-ng-core (<< ${source:Version}.1~)
Suggests: mongodb-server
Description: Enhanced system logging daemon (MongoDB plugin)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package provides the MongoDB destination plugin, which allows
 one to log system messages to MongoDB.

Package: syslog-ng-mod-sql
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, syslog-ng-core (>= ${source:Version}), syslog-ng-core (<< ${source:Version}.1~)
Suggests: libdbd-mysql, libdbd-pgsql, libdbd-sqlite3
Description: Enhanced system logging daemon (SQL plugin)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package provides the SQL destination plugin, which allows one to
 log system messages to a multitude of SQL databases (including, but
 not limited to MySQL, PostgreSQL and SQLite).

Package: syslog-ng-mod-smtp
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, syslog-ng-core (>= ${source:Version}), syslog-ng-core (<< ${source:Version}.1~)
Description: Enhanced system logging daemon (SMTP plugin)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package provides the SMTP destination plugin, which allows one
 to send email messages from within syslog-ng itself.

Package: syslog-ng-mod-amqp
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, syslog-ng-core (>= ${source:Version}), syslog-ng-core (<< ${source:Version}.1~)
Suggests: rabbitmq-server
Description: Enhanced system logging daemon (AMQP plugin)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package provides the AMQP destination plugin, which allows one
 to publish log messages through the AMQP protocol.

Package: syslog-ng-mod-geoip2
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, syslog-ng-core (>= ${source:Version}), syslog-ng-core (<< ${source:Version}.1~)
Provides: syslog-ng-mod-geoip
Replaces: syslog-ng-mod-geoip (<< 3.25.1~)
Breaks: syslog-ng-mod-geoip (<< 3.25.1~)
Description: Enhanced system logging daemon (GeoIP2 plugin)
 syslog-ng is an enhanced log daemon, supporting a wide range of input
 and output methods: syslog, unstructured text, message queues,
 databases (SQL and NoSQL alike) and more.
 .
 Key features:
 .
  * receive and send RFC3164 and RFC5424 style syslog messages
  * work with any kind of unstructured data
  * receive and send JSON formatted messages
  * classify and structure logs with builtin parsers (csv-parser(),
    db-parser(), etc.)
  * normalize, crunch and process logs as they flow through the system
  * hand on messages for further processing using message queues (like
    AMQP), files or databases (like PostgreSQL or MongoDB).
 .
 This package provides the GeoIP2 template function plugin, which
 allows one to do non-DNS IP-to-country resolving from syslog-ng
 templates. GeoIP2 uses MaxMind DB.

Package: syslog-ng-mod-redis
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, syslog-ng-core (>= ${source:Version}), syslog-ng-core (<< ${source:Version}.1~)
Description: Enhanced system logging daemon (Redis plugin)

=== debian/rules ===
#! /usr/bin/make -f
## debian/rules file for syslog-ng 3.3+
## (C) 2010-2012 Laszlo Boszormenyi (GCS) <gcs@debian.hu>
## (C) 2011-2014 Gergely Nagy <algernon@madhouse-project.org>
##
## Released under the GPLv2+, see /usr/share/common-licenses/GPL-2 on
## Debian systems.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For my own sanity, when debian/rules is ran without any argument,
# display something meaningful, instead of just running the first
# override.
help:
	sensible-pager debian/README.source

##
#* Environment setup
#
# If DEB_BUILD_OPTIONS has "debug" in it, we want to pass
# --enable-debug to configure.
#
# We also want to build in a separate build directory:
# debian/build-tree, because it's just so much easier to ignore files
# in there.
#
# By the way, if one wants to pass extra flags to configure, that can
# be done with EXTRA_CONFIGURE_OPTS, we don't override it, only append
# to it.
##
ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
EXTRA_CONFIGURE_OPTS += --enable-debug
endif

# We want to support building from a git tree, where the syslog-ng
# sources are in a submodule, in syslog-ng-*. Since we do not wish to
# update the rules for every major version if it can be helped, figure
# it out from the changelog instead.
UMAJOR		   = $(shell dpkg-parsechangelog | sed -n '/^Version:/s/^Version: //p' | cut -d. -f1,2)

export DH_OPTIONS += -O-Bdebian/build-tree --dbg-package=syslog-ng-dbg

CFLAGS		?= $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS		?= $(shell dpkg-buildflags --get LDFLAGS)

MULTIARCH_PATH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# We want to enforce systemd support on Linux, but disable it
# everywhere else.
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_OS),linux)
SYSTEMD_CONFIGURE_OPTS = --enable-systemd --with-systemd-journal=system
PACCT_CONFIGURE_OPTS   = --enable-pacct
else
SYSTEMD_CONFIGURE_OPTS = --disable-systemd
PACCT_CONFIGURE_OPTS   = --disable-pacct
endif

# If DH_QUIET is set, then we want silent mode.
# If DH_VERBOSE is set, we do not want silent mode.
# If neither is set, we want the default: verbose mode.
SILENT_MODE	       = --disable-silent-rules
ifneq (,${DH_QUIET})
SILENT_MODE	       = --enable-silent-rules
endif
ifneq (,${DH_VERBOSE})
SILENT_MODE	       = --disable-silent-rules
endif

##
#* Overrides for dh_auto*
##

# Oh, the joys of configure!
# We pass down all appropriate options, along with EXTRA_CONFIGURE_OPTS.
# This also sets SOURCE_REVISION to the debian package version.
override_dh_auto_configure:
	install -d debian/build-tree
	-rm -rf doc/man/*.?
	SOURCE_REVISION="$(shell dpkg-parsechangelog | \
			  sed -n '/^Version:/s/^Version: //p')"; \
	dh_auto_configure -- \
		--build=$(dpkg-architecture -qDEB_BUILD_GNU_TYPE) \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--sysconfdir=/etc/syslog-ng \
		--localstatedir=/var/lib/syslog-ng \
		--libdir=/usr/lib/syslog-ng \
		${SILENT_MODE} \
		\
		--enable-dynamic-linking \
		--enable-ssl \
		--enable-spoof-source \
		--enable-tcp-wrapper \
		--enable-sql \
		--enable-mongodb \
		--enable-json \
		--enable-riemann \
		--disable-java \
		--enable-manpages \
		--enable-amqp \
		$(PACCT_CONFIGURE_OPTS) \
		--enable-python \
		--with-python=3 \
		--enable-http \
		--enable-kafka \
		\
		--with-mongoc=system \
		--with-ivykis=system \
		--with-jsonc=system \
		--with-librabbitmq-client=system \
		\
		--with-module-dir='$${exec_prefix}/lib/syslog-ng/${UMAJOR}' \
		--with-systemdsystemunitdir="/lib/systemd/system" \
		\
		SOURCE_REVISION="$${SOURCE_REVISION}" \
		${SYSTEMD_CONFIGURE_OPTS} \
		${EXTRA_CONFIGURE_OPTS}

# The pkg-config .pc file is installed into ${libdir}/pkgconfig, but
# we override libdir above to place everything useful there. We want
# the .pc file elsewhere, though, so do that here at install time.
#
# Similarly, we want to install python modules to their proper place,
# and this is a great time to tell the build system where that is.
# Also removing .la files, these files don't needed and just confuse
# the list-missing option
override_dh_auto_install:
	dh_auto_install -- \
		pkgconfigdir=/usr/lib/$(MULTIARCH_PATH)/pkgconfig \
		PYSETUP_OPTIONS="--install-layout=deb \
		--root=$(CURDIR)/debian/tmp/"
	find . -name \*.la | xargs --no-run-if-empty rm
	[ ! -f $(CURDIR)/debian/tmp/usr/share/syslog-ng/tools/merge-grammar.py ] || \
		sed -i 's/ python$$/ python3/' \
		$(CURDIR)/debian/tmp/usr/share/syslog-ng/tools/merge-grammar.py
	# installed manually
	rm -rf debian/tmp/usr/share/syslog-ng/include/scl/checkpoint/ \
		debian/tmp/usr/share/syslog-ng/include/scl/collectd/ \
		debian/tmp/usr/share/syslog-ng/include/scl/elasticsearch/ \
		debian/tmp/usr/share/syslog-ng/include/scl/junos/ \
		debian/tmp/usr/share/syslog-ng/include/scl/netskope/ \
		debian/tmp/usr/share/syslog-ng/include/scl/websense/ \
		debian/tmp/usr/share/syslog-ng/include/scl/sumologic/

# To get better test results, and actually see failing tests, we need
# to pass VERBOSE=1 to make when running the tests. Do that here.
override_dh_auto_test:
	# disabled ATM
	#dh_auto_test -- VERBOSE=1

##
#* Overrides for other debhelper commands
#
# Below are overrides for individual debhelper commands.
##

# Install the NEWS file as upstream changelog.
# Rationale: the ChangeLog file is an old artifact from the Arch
# times. It is not updated, and is obsolete.
override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

# Init files and whatnot were moved to syslog-ng-core, but we want to
# retain the old filenames.
override_dh_installinit:
	dh_installinit --name syslog-ng --restart-after-upgrade

# Logrotate and Logcheck files were moved from syslog-ng to
# syslog-ng-core too, and like in init's case, we want to keep the old
# name.
override_dh_installlogrotate:
	dh_installlogrotate --name syslog-ng

override_dh_installlogcheck:
	dh_installlogcheck --name syslog-ng

# dh_makeshlibs wants to be clever and treat plugins as shared libs.
# Slap it in the face, and tell it not to. We also do not need any
# script modifications, as our single shared lib is in a private
# directory. On the other hand, we do want correct dependencies on
# anything that build-depends on syslog-ng-dev, so lets make a correct
# shlibs file for that, shall we?
#
override_dh_makeshlibs:
	dh_makeshlibs -n -Xusr/lib/syslog-ng/${UMAJOR}

# Since syslog-ng depends on all the modules, and syslog-ng-core
# suggests the same set, and modules can come and go as new versions
# of syslog-ng come out, lets make our life easy, and provide a custom
# sng:Modules substvar, which has all the module packages listed. We
# also provide sng:CoreModules, which lists core modules that were
# part of syslog-ng (or it depended on them) previously, in 3.3.
override_dh_gencontrol:
	dh_gencontrol -- -Vsng:Modules=$(shell debian/tools/list-modules.sh optional) \
			 -Vsng:CoreModules=$(shell debian/tools/list-modules.sh core)

# Sadly, dh_python2 barfs on --dbg-package=, so we work it around by
# clearing DH_OPTIONS here.
override_dh_python2:
	DH_OPTIONS="" dh_python2

# Sadly, dh_python3 barfs on --dbg-package=, so we work it around by
# clearing DH_OPTIONS here.
override_dh_python3:
	DH_OPTIONS="" dh_python3

##
#* Other, non-override targets
##

override_dh_missing:
	dh_missing $(shell awk '{sub(/.*\//, "", $$1); print "-X"$$2"/"$$1}' debian/syslog-ng-mod-extra.install) --fail-missing

# By default, the arch:all syslog-ng package does not need anything
# built, so build-indep shall be empty. This avoids triggering another
# build attempt, which would fail due to autoreconf being run
# twice. It would also fail if no build-deps were installed (since the
# package has no build-dep-indeps, rightly so).
build-indep: ;

# And for the rest, there is debhelper!
%:
	dh $@ --with autoreconf,python3
